/**
* BSOgreDataStreamSource.cpp
* 
* Project: cAudioSoundSystem
* Author: Murat Sari
* Created: 2011-01-20
*
* Copyright: www.team-bytestorm.com/license.html, 2008 - 2011
*/
#pragma once

// Project Includes
#include "BSOgreDataStreamSource.h"

namespace BS 
{
	namespace Sound 
	{
		//-----------------------------------------------------------------------	
		bool OgreDataStreamSource::isValid()
		{
			return !m_DataStream.isNull() && m_DataStream->isReadable();
		}
		//-----------------------------------------------------------------------	
		int OgreDataStreamSource::getCurrentPos() 
		{
			if (!m_DataStream.isNull())
			{
				return m_DataStream->tell();
			}
			return 0;
		}
		//-----------------------------------------------------------------------	
		int OgreDataStreamSource::getSize()
		{
			if (!m_DataStream.isNull())
			{
				return m_DataStream->size();
			}
			return 0;
		}
		//-----------------------------------------------------------------------	
		int OgreDataStreamSource::read(void* output, int size)
		{
			if (!m_DataStream.isNull())
			{
				return m_DataStream->read(output, size);
			}
			return 0;
		}
		//-----------------------------------------------------------------------	
		bool OgreDataStreamSource::seek(int amount, bool relative)
		{
			if (!m_DataStream.isNull())
			{
				if(relative)
				{
					int oldamount = getCurrentPos();
					m_DataStream->skip(amount);

					//check against the absolute position
					if(oldamount + amount !=  getCurrentPos())
						return false;
				}
				else
				{
					m_DataStream->seek(amount);
					if(amount != getCurrentPos())
						return false;
				}				
				return true;
			}
			return false;
		}
		//-----------------------------------------------------------------------	
	}
}