/**
* BSOgreDataStreamSource.h
* 
* Project: cAudioSoundSystem
* Author: Murat Sari
* Created: 2011-01-20
*
* Copyright: www.team-bytestorm.com/license.html, 2008 - 2011
*/
#pragma once

// Project Includes
#include "IDataSource.h"
#include "OgreDataStream.h"
#include "../Headers/cMemoryOverride.h"

namespace BS 
{
	namespace Sound 
	{
		class OgreDataStreamSource : public cAudio::IDataSource, public cAudio::cMemoryOverride
		{
		public:
			OgreDataStreamSource(Ogre::DataStreamPtr dataStream) : m_DataStream(dataStream) {}
			virtual ~OgreDataStreamSource() {}
			
			virtual bool isValid();
			virtual int getCurrentPos() ;
			virtual int getSize();
			virtual int read(void* output, int size);
			virtual bool seek(int amount, bool relative);
		private:
			Ogre::DataStreamPtr m_DataStream;
		};
	}
}