/**
* BSOgreDataStreamSourceFactory.cpp
* 
* Project: cAudioSoundSystem
* Author: Murat Sari
* Created: 2011-01-20
*
* Copyright: www.team-bytestorm.com/license.html, 2008 - 2011
*/

// Project Includes
#include "cAudioMemory.h"
#include "BSOgreDataStreamSourceFactory.h"
#include "BSOgreDataStreamSource.h"
#include "OgreResourceGroupManager.h"
#include "OgreRoot.h"

namespace BS 
{
	namespace Sound 
	{
		cAudio::IDataSource* OgreDataStreamSourceFactory::CreateDataSource(const char* filename, bool streamingRequested)
		{
			cAudio::cAudioMutexBasicLock lock(Mutex);

			if (Ogre::Root::getSingletonPtr()->isInitialised())
			{				
				Ogre::StringVectorPtr files = Ogre::ResourceGroupManager::getSingletonPtr()->findResourceLocation(Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME, filename);
				if (files->size() > 0)
				{					
					return CAUDIO_NEW OgreDataStreamSource(Ogre::ResourceGroupManager::getSingletonPtr()->openResource(files->at(0)));
				}	
			}
			return NULL;
		}
	}
}